




(function (window){
	function InnovationSlider(left,right){
		this.initialize();
		
		var LEFT = 74;
		var ACTIVE_WIDTH = 1000;
		var blocked = false;
		var blocker;
		var readIn = false;
		var cacheIn = 50;
		
		var mouseDown = false;
		var oldX;
		var newX;
		
		var active = new Array();
		var innovators = new Array();
		var boxes = new Array();
		var impInnovators = new Array();
		var lessImp = new Array();
		var taglines = new Array();
		var innovNum = 0;
		var innovInd = 0;
		
		var slidingRight = false;
		var slidingLeft = false;
		var slideBuffer = 0;
		
		var rows = 3;
		function rowSize(){return screen_height/rows;}
		var columns = 6;
		function colSize(){return ACTIVE_WIDTH/columns;}
		
		var currentCol = LEFT - colSize();
		var currentRow = 0;
		
		var colList = new Array();
		var activeCol = 0;
		var _belt;
		
		var currentFilter = 0;
		
		var changedCol = false;
		
		function colLeft(){
			activeCol--; 
			if (activeCol < 0)
				activeCol = colList.length-1;
			changedCol = true;
		}
		
		function colRight(){
			activeCol++;
			if (activeCol == colList.length)
				activeCol = 0;
			changedCol = true;
		}
		
		var _left = left;
		var _right = right;
		
		_left.onClick = shiftRight;
		_right.onClick = shiftLeft;
		
		getInnovators();
		
		function getInnovators(filter){
			
			while (innovators.length > 0)
				innovators.pop();
				
			while (impInnovators.length > 0)
				impInnovators.pop();
				
			while (lessImp.length > 0)
				lessImp.pop();
			
			readIn = false;
			innovNum = 0;
			innovInd = 0;
			var data;
			
			if (filter && filter != 0){
			
				
				createjs.Tween.get(_belt).to({alpha:0},700);
				
				setTimeout(function(){
					$.getJSON(API+"StoriesByFilter/"+filter, function(json) {
						   for (var i = 0; i < json.length;i++){
								innovators.push(new Innovator(json[i],taglines))
						   }
						   shuffle(innovators);
						   for (var i = 0; i < innovators.length;i++){
								
								if (innovators[i].priority == 3){
								
									impInnovators.push(innovators[i]);
									}
									
								
								if (innovators[i].priority == 2){
									
									lessImp.push(innovators[i]);
								}
						   }
						   
						   innovNum = innovators.length;
						   readIn = true;
						   slider.add();
						 });
				},710);
				
			}
			else if (filter == 0){
				createjs.Tween.get(_belt).to({alpha:0},700);
				
				setTimeout(function(){
					$.getJSON(API+"Stories", function(json) {
						   for (var i = 0; i < json.length;i++){
								innovators.push(new Innovator(json[i],taglines))
						   }
						   shuffle(innovators);
						   for (var i = 0; i < innovators.length;i++){
								
								if (innovators[i].priority == 3){
								
									impInnovators.push(innovators[i]);
									}
									
								
								if (innovators[i].priority == 2){
									
									lessImp.push(innovators[i]);
								}
						   }
						   
						   innovNum = innovators.length;
						   readIn = true;
						   slider.add();
						 });
				},710);
			}
			else{
				
				$.getJSON(API+"Taglines", function(tags) {
					
					for (var i =0; i < tags.length;i++){
						taglines[tags[i].TaglineID-1] = tags[i].Name;
					}
					
					populateAddStory(taglines);
					if (urlParams["prof"]){
						 $.getJSON(API+"Stories/"+urlParams["prof"], function(stor) {
							slideInProfile(new Innovator(stor[0],taglines));
						 });
					}
				
					$.getJSON(API+"Stories", function(json) {
					   for (var i = 0; i < json.length;i++){
							innovators.push(new Innovator(json[i],taglines))
					   }
					   shuffle(innovators);
					   for (var i = 0; i < innovators.length;i++){
								
							if (innovators[i].priority == 3){
							
								impInnovators.push(innovators[i]);
								}
								
							
							if (innovators[i].priority == 2){
						
								lessImp.push(innovators[i]);
							}
					   }
					   innovNum = innovators.length;
					   readIn = true;
					   slider.add();
					 });
				 });
			}
		}
		
		this.add = function(){
		
			if (readIn){
				changedCol = false;
				while(active.length>0)
					slider.removeChild(active.pop());
					
				while (boxes.length > 0){
					boxes.pop();
				}
				
				while(colList.length>0){
					var c = colList.pop();
					if (c.parent){
						c.parent.removeChild(c);
					}
				}
				
				for (var i = 0; i < innovators.length;i++){
					innovators[i].used = false;
				}
				
				currentRow = 0;
				currentCol = LEFT - colSize();
				
				for (var i = 0; i < columns+2; i++){
						for (var j=0; j< rows; j++){
							addBox();
						}
				}
				
				innovInd = 0;
				activeCol = 0;
				
				while (boxes.length < innovNum || colList.length < 5){
					var nCol = buildCol();
					nCol.onTick = function(){
						if (this.parent){
							if (this.x + this.parent.x < LEFT){
								this.alpha = 1 - ((LEFT-(this.x + this.parent.x))/(2*colSize()))
								}
							else if (this.x + this.parent.x > LEFT + colSize()*(columns-2)){
								this.alpha = 1- ((this.x + this.parent.x) - (LEFT+colSize()*(columns-2)))/(2*colSize());
								
								}
							else
								this.alpha = 1;
						}
					}
					colList.push(nCol);
					
				}
				
				for (var i = 0; i < boxes.length;i++){
					if (boxes[i].size == "large"){
						fillPersonBox(boxes[i],nextInnovator());
						boxes[i].full = true;
					}
				}
				
				for (var i = 0; i < boxes.length;i++){
					if (boxes[i].size == "wide" || boxes[i].size == "tall"){
						fillPersonBox(boxes[i],nextInnovator(boxes[i].size));
						boxes[i].full = true;
					}
				}
				
				for (var i = 0; i < boxes.length;i++){
					if (!boxes[i].full)
						fillPersonBox(boxes[i],nextInnovator());
				}
				
				var colCont = new createjs.Container();
				for (var i = 0; i < colList.length; i++){
					colList[i].x = i*colSize()*2;
					colCont.addChild(colList[i]);
				}
				

				colCont.x = LEFT;
				colCont.width = colCont.getNumChildren()*colSize()*2;
				
				_belt = colCont;
		
				_belt.alpha = 0;
				slider.addChild(_belt);
				createjs.Tween.get(_belt).to({alpha:1},700);
				changedCol = true;
				

				
				
			}
		}
		
		function addBox(){
			var box = new createjs.Shape();
			var g = box.graphics;
			g.beginFill(createjs.Graphics.getRGB(240,240,240));
			g.drawRoundRect(0,0,colSize() - 10,rowSize()-10,5);
			g.endFill()
			
			box.x += currentCol;
			box.y += currentRow;
			box.alpha = 0;
			slider.addChild(box);
			createjs.Tween.get(box).to({alpha:1},1000);
			active.push(box)
			currentRow += rowSize();
			if (currentRow >= screen_height){
				currentRow = 0;
				currentCol += colSize();
			}
		}
		
		var tillBig = Math.floor(columns/2*Math.random());
		
		function buildCol(){
			
			var atTop = true;
			
			var toBuild = new createjs.Container();
			
			var maxWidth = 2;
			var maxHeight;
			
				
			if (rows >= 2)
				maxHeight = 2;
			else 
				maxHeight = 1;
				
			var empty = new Array(maxWidth);
			
			for (var i = 0; i < maxWidth;i++){
				empty[i] = new Array(rows);
				for (var j = 0; j < rows;j++){
					empty[i][j] = true;
				}
			}
			
			fillCol(0,0);
			
			function fillCol(left,top){
				
				var box;
				var size;
				
				//LARGER BOXES AVAILABLE
				if(empty[left][top+1] || (empty[left+1] && empty[left+1][top]) ){
				
					if (empty[left][top+1] &&(empty[left+1] && empty[left+1][top])){
						
						if ( tillBig == 0){
							if (rows == 2 || !atTop || 100*Math.random() < 50){
								size = "large";
								tillBig = 3;
								}
							else{
								size = "wide";
								atTop = false;
								}
						}
						else{
						
							var randChoice = 100*Math.random();
							
							if(randChoice < 30){
								size = "wide";
							}
							else if(randChoice < 70){
								size = "tall";
							}
							else{
								size = "small";
							}
						}
					}
					else if (empty[left][top+1]){
						var randChoice = 100*Math.random();
						if(randChoice < 80){
							size = "tall";
						}
						else{
							size = "small";
						}
					}
					else{
						var randChoice = 100*Math.random();
						if(randChoice < 80){
							size = "wide";
						}
						else{
							size = "small";
						}
					}
				}
				//SMALL BOX
				else{
					size = "small";	
				}
				
				empty[left][top] = false;
				
				if (size == "tall" || size =="large"){
					empty[left][top+1] = false;
				}
				if (size == "wide" || size =="large"){
					empty[left+1][top] = false;
				}
				if (size == "large"){
					empty[left+1][top+1] = false;
				}
				
				box = getPersonBox(size);
				
				box.x = left*colSize();
				box.y = top*rowSize();
				boxes.push(box);
				
				toBuild.addChild(box);	
				
				var foundEmpty = false;
				for ( var i = 0; i < empty.length && !foundEmpty;i++){
					for( var j = 0; j < empty[i].length && !foundEmpty;j++){
						if ( empty[i][j]){
							foundEmpty = true;
							fillCol(i,j);
						}
					}
				}
			
			}
			
			function getPersonBox(size){
					
			
				var persBox = new createjs.Container();
				persBox.size = size;
				
				
			
				
				var bg = new createjs.Shape();
				var g = bg.graphics;
				g.beginFill("#d1d1d1");
				
				switch(size){
					case "small":
						g.rect(0,0,colSize()-10,rowSize()-10);
						persBox.width = colSize()-10;
						persBox.height = rowSize()-10;
						break;
					case "wide":
						g.rect(0,0,colSize()*2-10,rowSize()-10);
						persBox.width = colSize()*2-10;
						persBox.height = rowSize()-10;
						break;
					case "tall":
						g.rect(0,0,colSize()-10,rowSize()*2-10);
						persBox.width = colSize()-10;
						persBox.height = rowSize()*2-10;
						break;
					case "large":
						g.rect(0,0,colSize()*2-10,rowSize()*2-10);
						persBox.width = colSize()*2-10;
						persBox.height = rowSize()*2-10;
						break;
				}
				persBox.addChild(bg);
				persBox.size = size;
				return persBox;
			}
		
			tillBig--;
			return toBuild;
		}
		
		function fillPersonBox(persBox,pers){
			
			var pic = new Image();
			var size = persBox.size;
			persBox.innovator = pers;
			persBox.onPress = handlePress;
			var bit;
			pic.onload = function(){
				bit = new createjs.Bitmap(this);
				var scaleBy;
				
				if (size == "tall" || size =="small"){
					scaleBy = (colSize()-10)/bit.image.width;
				}
				else if (size =="large"){
						scaleBy = (colSize()*2-10)/bit.image.width;
				}
				else{
					scaleBy = (rowSize()-10)/bit.image.height;
				}
				bit.scaleX = scaleBy;
				bit.scaleY = scaleBy;
				
				if (size == "wide"){
					if (100*Math.random()<50)
						persBox.flipped = true;
				}
				
				if (persBox.flipped){
					bit.x += (colSize()*2-10) - bit.image.width*scaleBy;
				}
				
				persBox.addChild(bit);
				
				var name;
				var tag;
				var extra;
				
				if (size != "wide"){
					extra = (persBox.height-bit.image.height*scaleBy);
				}
				else{
					extra = persBox.height;
				}
				
				if (size=="large"){
					name = new createjs.Text("",Math.floor(extra/4.285)+"px UbuntuMedium");
					tag = new createjs.Text("",Math.floor(extra/5.625)+"px Ubuntu");
					tag.lineHeight = Math.floor(extra/5.625) + 2;
					name.lineHeight = Math.floor(extra/4.285) + 2;
				}
				if (size =="wide"){
					name = new createjs.Text("",Math.floor(extra/10.944)+"px UbuntuMedium ");
					tag = new createjs.Text("",Math.floor(extra/14.0714)+"px Ubuntu");
					name.lineHeight = Math.floor(extra/10.944)+2;
					tag.lineHeight = Math.floor(extra/14.0714)+2;
				}
				if (size =="tall"){
					name = new createjs.Text("",Math.floor(extra/5.7)+"px UbuntuMedium");
					tag = new createjs.Text("",Math.floor(extra/7.2)+"px Ubuntu");
					name.lineHeight = Math.floor(extra/5.7)+2;
					tag.lineHeight = Math.floor(extra/7.2)+2;
				}
				if (size =="small"){
					name = new createjs.Text("",Math.floor(extra/4.1286)+"px UbuntuMedium ");
					tag = new createjs.Text("",Math.floor(extra/4.78333)+"px Ubuntu");
					name.lineHeight = Math.floor(extra/4.0286)+2;
					tag.lineHeight = Math.floor(extra/4.68333)+2;
				}
				name.text = "I am "+persBox.innovator.name+".";
				tag.text = persBox.innovator.tagline;
				name.textAlign = "center";
				tag.textAlign = "center";
				
				if (size != "wide"){
					name.lineWidth = persBox.width*1;
					tag.lineWidth = persBox.width*1;
					
					if (size != "small"){
						name.lineWidth = persBox.width*.9;
						tag.lineWidth = persBox.width*.9;
					}
					
					
					name.x = persBox.width/2;
					tag.x = persBox.width/2;
					
					name.y = bit.image.height*scaleBy + (extra - name.getMeasuredHeight() - tag.getMeasuredHeight())/6;
					tag.y = name.y + name.getMeasuredHeight();
				}
				else{
					
					if (persBox.flipped){
						name.x = (persBox.width-(bit.image.width*scaleBy))/2
						tag.x = (persBox.width-(bit.image.width*scaleBy))/2
					}
					else{
						name.x = (persBox.width-(bit.image.width*scaleBy))/2 +bit.image.width*scaleBy;
						tag.x = (persBox.width-(bit.image.width*scaleBy))/2 +bit.image.width*scaleBy;
					}
					
					name.lineWidth = (persBox.width - bit.image.width*scaleBy)*0.9;
					tag.lineWidth = (persBox.width - bit.image.width*scaleBy)*0.9;
					
					name.y = (persBox.height -(name.getMeasuredHeight() + tag.getMeasuredHeight()))/2;
					tag.y = name.y + name.getMeasuredHeight();
				}
				
				persBox.addChild(name);
				persBox.addChild(tag);
			}
			
			switch (size){
				case "small":
					pic.src = PICTURE_PATH+persBox.innovator.picture+"_155140.png";
					break;
				case "large":
					pic.src = PICTURE_PATH+persBox.innovator.picture+"_320310.png";
					break;
				case "wide":
					pic.src = PICTURE_PATH+persBox.innovator.picture+"_165200.png";
					break;
				case "tall":
					pic.src = PICTURE_PATH+persBox.innovator.picture+"_155300.png ";
					break;
			}
		}
		
		function nextInnovator(){
			
			if (innovInd < innovNum){
				
				for (var i = 0; i < impInnovators.length;i++){
					if (!impInnovators[i].used){
						impInnovators[i].used = true;
						innovInd++;
						return impInnovators[i];
					}
				}
				
				for (var i = 0; i < lessImp.length;i++){
					if (!lessImp[i].used){
						lessImp[i].used = true;
						innovInd++;
						return lessImp[i];
					}
				}
				
					
				for (var i = 0; i < innovators.length;i++){
					if (!innovators[i].used){
						innovators[i].used = true;
						innovInd++;
						return innovators[i];
					}
				}
			
			}
			else{
				return innovators[Math.floor(innovators.length*Math.random())];
			}
		}
		
		var landscape = false;
		this.rebuild = function(width, height){
		
			if (width < 400 && columns != 2){
				
				columns = 2;
				rows = 1;
				landscape = false;
				slider.add();
				_left.scaleX = 2.2;
				_left.scaleY = 2.2;
				_left.x = 90;
				_right.scaleX = -2.2;
				_right.scaleY = 2.2;
				_right.x = 1048;
			}
			
			if (width >= 400 && width < 769 && columns != 4){
				
				columns = 4;
				rows = 2;
				landscape = false;
				
				slider.add();
				_left.scaleX = 2;
				_left.scaleY = 2;
				_left.x = 80;
				_right.scaleX = -2;
				_right.scaleY = 2;
				_right.x = 1058;
			}
			
			if (width >= 769 && width < 900 && columns != 4){
				columns = 4;
				rows = 2;
				landscape = false;
				
				slider.add();
				_left.scaleX = 1.5;
				_left.scaleY = 1.5;
				_left.x = 70;
				_right.scaleX = -1.5;
				_right.scaleY = 1.5;
				_right.x = 1068;
			}
			
			if (width >= 900 && columns != 6){
				landscape = false;
				columns = 6;
				rows = 3;
			
				
				slider.add();
				_left.scaleX = 1;
				_left.scaleY = 1;
				_left.x = 60;
				_right.scaleX = -1;
				_right.scaleY = 1;
				_right.x = 1078;
			}
			
			if (width > height*1.6 && !landscape){
				landscape = true;
				_left.scaleX += _left.scaleX*0.5;
				_left.scaleY += _left.scaleY*0.5;
				_left.x += 15;
				
				_right.scaleX += _right.scaleX*0.5;
				_right.scaleY += _right.scaleY*0.5;
				_right.x -= 15;
			}
			else if(width <= height*1.6 && landscape){
				landscape = false;
				_left.scaleX = _left.scaleX/1.5;
				_left.scaleY = _left.scaleY/1.5;
				_left.x -= 15;
				
				_right.scaleX = _right.scaleX/1.5;
				_right.scaleY = _right.scaleY/1.5;
				_right.x += 15;
			}
			
			
		}
		
		this.addFilter = function(id){
			getInnovators(id);
		}
		
		this.onTick = function(){
			
			if (mouseDown){
				
				_belt.x = _belt.oldX + (newX-oldX)
				
				if (newX-oldX > 2*colSize())
					movedRight();
					
				if (oldX-newX > 2*colSize())
					movedLeft();

			}
			
			if (changedCol){
				var left1 = activeCol-1;
				var left2 = activeCol-2;
				if (left1 < 0)
					left1 = colList.length + left1;
				colList[left1].x = colList[activeCol].x - 2*colSize();
				
				if (left2 < 0)
					left2 = colList.length + left2;
					
				colList[left2].x = colList[activeCol].x - 4*colSize();
					
				var right1 = activeCol + 1;
				var right2 = activeCol + 2;
				var right3 = activeCol + 3;
				if (right1 >= colList.length)
					right1 -= colList.length;
				colList[right1].x = colList[activeCol].x + 2*colSize();
				
				if (right2 >= colList.length)
					right2 -= colList.length;
				colList[right2].x = colList[activeCol].x + 4*colSize();
				
				if (right3 >= colList.length)
					right3 -= colList.length;
				colList[right3].x = colList[activeCol].x + 6*colSize();
				
				changedCol = false;
			}
				
			
			
		}
		
		function movedRight(){

			mouseDown = false;
			_belt.oldX = _belt.x;
			oldX = newX;
			colLeft();
			mouseDown = true;
			
		}
		
		function movedLeft(){
			
			mouseDown=false;
			_belt.oldX = _belt.x;
			oldX = newX;
			colRight();
			mouseDown = true;
		
		}
		
		function handlePress(e){
			if (!blocked){
				slideBuffer=0;
				oldX = e.stageX;
				newX = e.stageX;
				_belt.oldX = _belt.x;
				var isClick = true;
				mouseDown = true;
				e.onMouseMove = function(ev){
					if (mouseDown){
						isClick = false;
						newX = ev.stageX;
					}
				}
				e.onMouseUp = function(ev){
					if (!blocked){
						if (isClick)
							slideInProfile(ev.target.innovator,taglines);
						else{
							if (Math.abs(colList[activeCol].x + _belt.x -LEFT) < colSize()){
								createjs.Tween.get(_belt).to({x:_belt.x -(colList[activeCol].x + _belt.x -LEFT) },Math.abs((colList[activeCol].x + _belt.x -LEFT))/colSize()*500);
							}
							else if (colList[activeCol].x + _belt.x -LEFT < 0){
								createjs.Tween.get(_belt).to({x:_belt.x + (-2*colSize())-(colList[activeCol].x + _belt.x -LEFT) },Math.abs((-2*colSize())-(colList[activeCol].x + _belt.x -LEFT))/colSize()*500);
								colRight();
							}
							else if(colList[activeCol].x + _belt.x -LEFT > 0){
								createjs.Tween.get(_belt).to({x:_belt.x + (2*colSize())-(colList[activeCol].x + _belt.x -LEFT) },Math.abs((2*colSize())-(colList[activeCol].x + _belt.x -LEFT))/colSize()*500);
								colLeft();
							}
						
						}				
						
						mouseDown = false;
					}
				}
			}
			else{
				e.onMouseUp = function(){};
				e.onMouseMove = function(){};
			}
		}
		
		var fastClick = false;
		
		function shiftRight(){
			if (!fastClick){
				fastClick = true;
				setTimeout(function(){fastClick = false},300);
				if (slidingRight){
					if (slideBuffer < 6)
						slideBuffer++;
				}
				else if (slidingLeft)
					slideBuffer = 0;
				else{
					slide();
				}				
			}
			function slide(){
					slidingRight = true;
						createjs.Tween.get(_belt).to({x:_belt.x + 2*colSize()},500);
						

						setTimeout(function(){
							if (slideBuffer == 0){
									slidingRight = false;
									}
								else{
									slideBuffer--;
									slide();
								}
						},525);
						colLeft();
				}
		}
		
		function shiftLeft(){
			// colList, activeCol
			if (!fastClick){
				fastClick = true;
				setTimeout(function(){fastClick = false},300);
				if (slidingLeft){
					if (slideBuffer < 6)
						slideBuffer++;
				}
				else if (slidingRight)
					slideBuffer = 0;
				else{
					slide();
				}
				
				
			}
			
			function slide(){
					slidingLeft = true;
					createjs.Tween.get(_belt).to({x:_belt.x - 2*colSize()},500);
						setTimeout(function(){
								if (slideBuffer == 0)
									slidingLeft = false;
								else{
									slideBuffer--;
									slide();
								}
						},525);
						
						colRight();
				}
		}
		
		function blockClick(){
			blocked = true;
			blocker = new createjs.Shape();
			blocker.graphics.beginFill("#000000");
			blocker.graphics.rect(0,0,screen_width,screen_height);
			blocker.alpha = 0;
			blocker.onClick = function(){}
			blocker.onPress = function(){}
			stage.addChild(blocker);
			createjs.Tween.get(blocker).to({alpha:0.498},300);
		}
		
		this.unBlock = function(){
			if(blocked){
			
			createjs.Tween.get(blocker).to({alpha:0},300);
			setTimeout(function(){
				stage.removeChild(blocker);},300);
			blocked = false;
			}
			
		}
		
		function slideInProfile(innov,taglines){
			blockClick();
			populateProfile(innov);
			
		}
	}
	
	
		
		InnovationSlider.prototype = new createjs.Container();
		
		InnovationSlider.prototype.Container_initialize = InnovationSlider.prototype.initialize;
		
		InnovationSlider.prototype.initialize = function(){
			this.Container_initialize();
			this.name = 'InnovationSlider';
			this.snapToPixel = true;
		}
		window.InnovationSlider = InnovationSlider;
}(window));




function Innovator(info,taglines){

	this.name;
	this.picture;
	this.video;
	this.about;
	this.college;
	this.degree;
	this.city;
	this.state;
	this.country;
	this.id;
	this.tagline;
	this.blurb;
	this.priority;
	this.ext;
	this.used = false;
	
	var self = this;
	
	if (info){
		this.name = info.Name;
		this.picture = info.Photo;
		this.video = info.Video;
		this.tagline = taglines[info.TaglineID-1];
		this.college = info.College;
		this.degree = info.Degree;
		this.country = info.HomeCountry;
		this.city = info.City;
		this.state = info.State;
		this.ext = info.PhotoExtension;
		this.id = info.StoryID;
		this.about = "";
		if (info.City){
			this.about += info.City; 
			if (info.State)
				this.about += ", "
			else
				this.about +="<br>"
		}
		if (info.State)
			this.about += info.State +"<br>";
		if (info.College)
			this.about += "School: "+ info.College +"<br>";
		if (info.Degree)
			this.about += "Degree: "+ info.Degree +"<br>";
		if (info.HomeCountry && info.HomeCountry !="USA")
			this.about += "Home Country: "+ info.HomeCountry;
			
		this.blurb = info.Story;
		this.priority = info.StoryLevel;		
	}
	
	

}

function populateAddStory(lines){
	var insert = "";
	for (var i in lines){
	
			var opt = "<option value='"+(parseInt(i)+1)+"'>"+lines[i]+"</option>";
			insert += opt;
	}
	document.getElementById("TaglineID").innerHTML = insert;
	
	$.getJSON(API+"Countries", function(json) {
	   
	   var cInsert = "";
	   for (var i = 0; i < json.length;i++){
			var opt = "<option value='"+json[i]+"'>"+json[i]+"</option>";
			cInsert += opt;
	   }
	   
	   document.getElementById("HomeCountry").innerHTML = cInsert;
	   
	 });
	 
	 $.getJSON(API+"States", function(json) {
	   
	   var sInsert = "";
	   for (var i = 0; i < json.length;i++){
			var opt = "<option value='"+json[i]+"'>"+json[i]+"</option>";
			sInsert += opt;
	   }
	   
	   document.getElementById("State").innerHTML = sInsert;
	   
	 });
	 
	 $.getJSON(API+"Filters", function(json) {
	   
	   var fInsert = "<p>Show All</p>";
	   for (var i = 0; i < json.length;i++){
			var opt = "<p>"+json[i].Name+"</p>";
			fInsert += opt;
	   }
	   
	   document.getElementById("filter_box").innerHTML = fInsert;
	   
	   var filts = document.getElementById("filter_box").getElementsByTagName("p");
	   
	   for (var i = 0; i < filts.length;i++){
			filts[i].value = i;
			$(filts[i]).bind('touchstart',function(e){
				e.preventDefault();
				slider.addFilter(this.value);
				boxOut(e);
			});
	   }
	   
	 });
	 
	 $.getJSON(API+"InfoGraphics", function(json) {
	   
	   var iInsert = "";
	   for (var i = 0; i < json.length;i++){
			var opt;
			if (i == 0)
				opt = "<option value='"+json[i].FileName+"' selected>"+json[i].Description+"</option>";
			else
				opt = "<option value='"+json[i].FileName+"'>"+json[i].Description+"</option>";
			iInsert += opt;
	   }
	   
	   document.getElementById("Infographic").innerHTML = iInsert;
	   
	 });
}

var hasVideo = false;

function clearProfile(){
	var pers = document.getElementById("person");
	pers.getElementsByTagName("p").innerHTML = "";
	document.getElementById("wrapVid").innerHTML = "<img class='pers_central' id='photo'></img>";
	$('#photo').hide();
	//$('#wrapVid').hide();
	$('#photo').unbind('touchstart');
	
	var blurb = document.getElementById("blurb");
	var ps = blurb.getElementsByTagName("p");
	
	for (var i = 0; i < ps.length-2; i++)
		ps[i].innerHTML = "";
}

function populateProfile(innov){

	var pers = document.getElementById("person");
	var profPic = document.getElementById("photo");
	var profVid;
	
	addIndShare(innov);
	
	profPic.onload = function(){
		
		$('#photo').show();
		
		setTimeout(function(){
			if (!animation)
				$('#profile').animate({left:'6.508355321020229%'},1000);
			else
				$("#profile").toggleClass("profile_in");
		},200);
	}
	
	$('#photo').hide();
	
	profPic.src = "";

	profPic.src = PICTURE_PATH+ innov.picture+"_475450.png";


	if (innov.video){
		$('#photo').bind('touchstart',function(e){
			e.preventDefault();
			$('#photo').hide();
			document.getElementById("wrapVid").innerHTML = "<img class='pers_central' id='photo'></img><video width='100%' class='pers_central' id='prof_vid'></video>"+
				"<div style='background: #f0f0f0;border:0px;' class='pers_central'><img width='15%' src='assets/graphics/button_pause.png' style='float:left;' id='play_but'/>"+
				"<img width='15%' src='assets/graphics/button_fullscreen.png' style='float:right;' id='fullscreen'/>"+"<div style='clear: both' width='100%'></div></div>" ;
			
			profVid = document.getElementById('prof_vid');
			$("#prof_vid").bind('play',function(){
				document.getElementById('play_but').src = "assets/graphics/button_pause.png";
				$('#play_but').unbind('touchstart',playIt);
				$('#play_but').bind('touchstart',pauseIt);
			});
			
			$("#prof_vid").bind('pause',function(){
				document.getElementById('play_but').src = "assets/graphics/button_play.png";
				$('#play_but').unbind('touchstart',pauseIt);
				$('#play_but').bind('touchstart',playIt);
			})
			
			$('#play_but').bind('touchstart',pauseIt);

			$('#fullscreen').bind('touchstart',function(e){
				e.preventDefault();
				if (profVid.requestFullScreen) {
				  profVid.requestFullScreen();
				} else if (profVid.mozRequestFullScreen) {
				  profVid.mozRequestFullScreen();
				} else if (profVid.webkitRequestFullScreen) {
				  profVid.webkitRequestFullScreen();
				} else if(profVid.webkitEnterFullScreen){
					profVid.webkitEnterFullScreen();
				}
			});
			
			function playIt(e){
				e.preventDefault();
				profVid.play();
				this.src = "assets/graphics/button_pause.png";
				$('#play_but').unbind('touchstart',playIt);
				$('#play_but').bind('touchstart',pauseIt);
			}
			
			function pauseIt(e){
				e.preventDefault();
				profVid.pause();
				this.src = "assets/graphics/button_play.png";
				$('#play_but').unbind('touchstart',pauseIt);
				$('#play_but').bind('touchstart',playIt);
			}
			
			setVideoProperties(profVid);
		
			var vidSpecs = "<source src='"+VIDEO_PATH+innov.video+".mp4'>";
			
			profVid.innerHTML = vidSpecs;
			
			//profVid.load();
			profVid.play();
		});
		
	}
	persP = pers.getElementsByTagName("p");
	persP[0].innerHTML = innov.name;
	persP[1].innerHTML = innov.about;
	
	var blurb = document.getElementById("blurb");
	var blurbP = blurb.getElementsByTagName("p");
	blurbP[0].innerHTML = "I am "+innov.name+ ".<br>I am innovation.";
	blurbP[1].innerHTML = innov.tagline;
	
	blurb.getElementsByTagName("div")[0].innerHTML = innov.blurb;
}

function setVideoProperties(vid){
	vid.autoplay = true;
	vid.onload = function(){}
	vid.onended = function(){
		//$('#photo').show();
		this.load();
	}
}

function shuffle ( myArray ) {
  var i = myArray.length;
  if ( i == 0 ) return false;
  while ( --i ) {
     var j = Math.floor( Math.random() * ( i + 1 ) );
     var tempi = myArray[i];
     var tempj = myArray[j];
     myArray[i] = tempj;
     myArray[j] = tempi;
   }
}

function addIndShare(innov){
	
	
	var twit = "http://twitter.com/intent/tweet?source=sharethiscom&text="+encodeURIComponent(innov.name+": ")+"I%20Am%20Innovation%20%23iaminnovation&url=http%3A%2F%2Finnovation.ce.org%3Fprof%3D"+innov.id;
	var face = "http://www.facebook.com/sharer.php?u=http%3A%2F%2Finnovation.ce.org%3Fprof%3D"+innov.id+"&t="+encodeURIComponent(innov.name+": ")+"I%20am%20Innovation";
	var goog = "https://plus.google.com/share?url=http%3A%2F%2Finnovation.ce.org%3Fprof%3D"+innov.id;
	var link = "http://www.linkedin.com/shareArticle?mini=true&url=http%3A%2F%2Finnovation.ce.org%3Fprof%3D"+innov.id+"&title="+encodeURIComponent(innov.name+": ")+"I%20Am%20Innovation&source=http%3A%2F%2Finnovation.ce.org";
	
	var i_sh = document.getElementById('ind_share');
	
	i_sh.innerHTML = '';
	
	i_sh.innerHTML = "<img id='i_twitter' class='shareButton' src='http://innovation.ce.org/assets/graphics/twitter.png'/>"+
		"<img id='i_facebook' class='shareButton' src='http://innovation.ce.org/assets/graphics/facebook.png'/>"+
		"<img id='i_googleplus' class='shareButton' src='http://innovation.ce.org/assets/graphics/googleplus.png'/>"+
		"<img id='i_linkedin' class='shareButton' src='http://innovation.ce.org/assets/graphics/linkedin.png'/>";
	
	$('#i_twitter').unbind('touchstart');	
	$('#i_twitter').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(twit);
	});
	
	$('#i_facebook').unbind('touchstart');
	$('#i_facebook').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(face);
	});
	
	$('#i_googleplus').unbind('touchstart');
	$('#i_googleplus').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(goog);
	});
	
	$('#i_linkedin').unbind('touchstart');
	$('#i_linkedin').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(link);
	});
	
	$('.shareButton').css('margin-left','20px');
}








