
$("#addStory").hide();
$('.hide_input').hide();
$('.option2').hide();
$('#filter_box').hide();

var pictureSource;   // picture source
var destinationType;
var MOBILE_OS = "none";
var loadedImage = "";

var cam;

var urlParams = {};

$(document).ready(function(){


	document.addEventListener("deviceready",onDeviceReady,false);
	document.addForm.reset();
	clearProfile();
	
	(function () {
		var match,
			pl     = /\+/g,  // Regex for replacing addition symbol with a space
			search = /([^&=]+)=?([^&]*)/g,
			decode = function (s) { return decodeURIComponent(s.replace(pl, " ")); },
			query  = window.location.search.substring(1);

		while (match = search.exec(query))
		   urlParams[decode(match[1])] = decode(match[2]);
	})();
	
	var option = 1;
	
	var lastClick = false;
	
	$('#chooseGraphic').bind('touchstart',function(e){
		e.preventDefault();
		if (option == 1){
			$('.option1').hide();
			$('.option2').show();
			document.getElementById('chooseGraphic').innerHTML = "<u>Or Upload Photo</u>";
			var pic = document.getElementById("sampleImage");
			pic.src = PICTURE_PATH+document.getElementById("Infographic").value+"_320310.png";
			option = 2;
			
			if (MOBILE_OS != "none")
				$('#sampleImage').unbind('touchstart',uploadPhoto);
		}
		else{
			$('.option2').hide();
			$('.option1').show();
			document.getElementById('chooseGraphic').innerHTML = "<u>Or Choose Infographic</u>";
			var files = document.getElementById("File1").files;
			showThumbnail(files);
			option = 1;
			
			if (MOBILE_OS != "none")
				$('#sampleImage').bind('touchstart',uploadPhoto);
		}
	});
	
	$('#filter').bind('touchstart',boxIn);
	$('#mapLink').bind('touchstart',function(e){
		e.preventDefault();
		window.location.href = "map.html"});
	
	
	
	document.getElementById("Infographic").onchange = function(e) { 
	
		var pic = document.getElementById("sampleImage");
		pic.src = PICTURE_PATH+this.value+"_320310.png";
	
	};
	
	document.getElementById("File1").onchange = function(e) { 
	
		var files = this.files;
		showThumbnail(files);
	
	};
	
	function showThumbnail(files){
	  if (MOBILE_OS == "none"){
		  
		  for(var i=0;i<files.length;i++){
			var file = files[i];
			var imageType = /image.*/
			if(!file.type.match(imageType)){
			 specialAlert("Not a valid Image file","Try again");
			  continue;
			}

			var image = document.getElementById("sampleImage");
			image.file = file;

			var reader = new FileReader()
			reader.onload = (function(aImg){
			  return function(e){
				aImg.src = e.target.result;
			  };
			}(image))
			var ret = reader.readAsDataURL(file);
		  }
	  }
	  else{
			var image = document.getElementById("sampleImage");
			if (loadedImage != "")
				image.src = loadedImage;
			else
				image.src = "assets/graphics/smallIcon.png";
	  }
	}
   
   $('form').ajaxForm({
			
			success:function(response) { 
               
			   document.getElementById("submitBut").disabled = false;
			   if (response =="Success"){
				specialAlert ("Your story has been added and is awaiting approval!","Success!");
				$('#addStory').fadeOut(); 
				document.addForm.reset();
				}else{
					specialAlert("Sorry, there was an error in your submission. Make sure all required fields are correct and try again. -" + response,"error");
				}
				
            },
			beforeSerialize: function($form, options){
			
				if(MOBILE_OS !="none" && option == 1){
					mobileSubmit();
					return false;
					
				}
				else{
				if (document.getElementById('Name').value == "")
					specialAlert ("Please enter your name.","Required Field");
				else if(document.getElementById('City').value == ""){
					specialAlert ("Please enter your current city.","Required Field");
				}else if(document.getElementById('Story').value == ""){
					specialAlert ("Please enter some information about your story.","Required Field");
				}else if((document.getElementById('File1').value == "" && option == 1)||(document.getElementById('Infographic').value == "" && option == 2) ){
					specialAlert ("Please upload a photo or choose an infographic.","Required Field");
				}else{
					if (option == 2){
						document.getElementById('File1').setAttribute('type', 'input');
						document.getElementById('File1').setAttribute('type', 'file');
					}
					document.getElementById("submitBut").disabled = true;
					return true;
				}
				return false;
				}
			}
		});
		
	$('#close_button').bind('touchstart',function(e){
		e.preventDefault();
		
		if (!animation)
			$('#profile').animate({left:'-100%'},{duration:1000,complete:doneSliding});
		else{
			setTimeout(doneSliding,1000);
			$("#profile").toggleClass("profile_in");
		}
		
		function doneSliding()
		{
			//document.getElementById("prof_vid").pause();
			clearProfile();
			slider.unBlock();
		}
	});
	
	$('#close_story').bind('touchstart',function(e){
		e.preventDefault();
		$('#addStory').fadeOut();
	});
	
	$('#story').bind('touchstart', function(e){
		e.preventDefault();
		$('#addStory').fadeIn();
	});
});

function boxIn(e){
	e.preventDefault();
	$('#filter').unbind('touchstart',boxIn);
	$('#filter').bind('touchstart',boxOut);
	$("#filter_box").fadeIn();
}

function boxOut(e){
	e.preventDefault();
	$('#filter').unbind('touchstart',boxOut);
	$('#filter').bind('touchstart',boxIn);
	$("#filter_box").fadeOut();
}

function onDeviceReady(){
	
	if (navigator.network.connection.type == Connection.NONE){
		specialAlert('You must have an internet connection to run "Innovation"',"No Connection");
		document.getElementsByTagName('body')[0].innerHTML = "<img src='assets/graphics/footer_logo.png' style='width:90%; display:block; padding-top:20%; margin:auto;'/>";
		navigator.device.exitApp();
		
		
	}
	MOBILE_OS = device.platform;
	navigator.splashscreen.hide();
	adjustForMobile();
	document.addEventListener("offline", goesOffline, false);
	document.addEventListener("pause", appPaused, false);
	
	
	cam = new CameraAccess();
}

function appPaused(){
	profVid = document.getElementById('prof_vid');
	if (profVid)
		profVid.pause();
}

function goesOffline(){
	specialAlert ("You must be online to access I Am Innovation!","Connection Error");
	document.getElementsByTagName('body')[0].innerHTML = "<img src='assets/graphics/footer_logo.png' style='width:90%; display:block; padding-top:20%; margin:auto;'/>";

	navigator.device.exitApp();
	
}

function CameraAccess(){
	
	this.useExistingPhoto = function(e) {
	  capture(Camera.PictureSourceType.SAVEDPHOTOALBUM);
	};

	// take a new photo:
	this.takePhoto = function(e) {
	  capture(Camera.PictureSourceType.CAMERA);
	};

	// capture either new or existing photo:
	capture = function(sourceType) {
		navigator.camera.getPicture(onCaptureSuccess, onCaptureFail, {
			quality:50,
			destinationType: Camera.DestinationType.FILE_URI,
			sourceType: sourceType,
			correctOrientation: true
		  });
	};

	// if photo is captured successfully, then upload to server:
	function onCaptureSuccess(imageURI) {
		loadedImage = imageURI;
		var image = document.getElementById("sampleImage");	
		image.src = loadedImage;
	};

	// there was an error capturing the photo:
	function onCaptureFail(message) {
	  specialAlert("Couldn't upload image","Upload error");
	};
}

function mobileSubmit(){
	

	if (document.getElementById('Name').value == "")
		specialAlert ("Please enter your name.","Required Field");
	else if(document.getElementById('City').value == ""){
		specialAlert ("Please enter your current city.","Required Field");
	}else if(document.getElementById('Story').value == ""){
		specialAlert ("Please enter some information about your story.","Required Field");
	}else if(loadedImage ==""){
		specialAlert ("Please upload a photo or choose an infographic.","Required Field");
	}else{

		  var options = new FileUploadOptions();
		  options.fileKey = "File1";
		 
		  options.fileName = loadedImage.substr(loadedImage.lastIndexOf('/') + 1);
		  
		  var params = {
			TaglineID: document.getElementById('TaglineID').value,
			Name: document.getElementById('Name').value,
			HomeCountry: document.getElementById('HomeCountry').value,
			College: document.getElementById('College').value,
			Degree: document.getElementById('Degree').value,
			City: document.getElementById('City').value,
			State: document.getElementById('State').value,
			Zip: document.getElementById('Zip').value,
			CEmail: document.getElementById('CEmail').value,
			Story: document.getElementById('Story').value,
			Infographic: document.getElementById('Infographic').value,
			Video: document.getElementById('Video').value,
			StoryID: document.getElementById('StoryID').value,
			CreatedBy: document.getElementById('CreatedBy').value
		  };
		  options.params = params;
		  var ft = new FileTransfer();
		  document.getElementById("submitBut").disabled = true;
		 ft.upload(loadedImage, encodeURI(API+'addStory.aspx'), success, fail, options);
	
	}
	
	function success(response) {
		document.getElementById("submitBut").disabled = false;
		if (response.response == "Success"){
			specialAlert ("Your story has been added and is awaiting approval!","Success!");
			$('#addStory').fadeOut();
			document.getElementById("submitBut").disabled = false;
			document.addForm.reset();
		}
		else{
			specialAlert("Sorry, there was an error in the submission. Make sure all required fields are correct and try again. -" + response.response,"Error");
			}
	  };
	  
	  // callback if the photo fails to upload successfully.
	  
	  function fail(error) {
		document.getElementById("submitBut").disabled = false;
		specialAlert("An error has occurred: Code = " + error.code,"Error");
	  };
	  
	 
}


function adjustForMobile(){

	var ops = document.getElementsByClassName('option1');
	ops[0].innerHTML = "*Tap to upload a Photo of You";
	document.getElementById('File1').className = "noOption";
	$('#File1').hide();
	
	$('#sampleImage').bind('touchstart',uploadPhoto);
	
	
}

function uploadPhoto(e){

		e.preventDefault();
		 navigator.notification.confirm(
        'How would you like to choose your picture?',  // message
        uploadSelection,              // callback to invoke with index of button pressed
        'Add a Photo',            // title
        'Use the Camera, Upload a Photo'          // buttonLabels
    );
	
	function uploadSelection(choice){
		if (choice == 1)
			cam.takePhoto();
		if (choice == 2)
			cam.useExistingPhoto();
	}

	
}

function specialAlert(message,title){
	if (MOBILE_OS == "none")
		alert(message);
	else{
		navigator.notification.alert(message,function(){},title);
	}
}

