var canvas;
var stage;
var screen_width;
var screen_height;
var slider;

var IMAGE_PATH = "assets/graphics/";
var PICTURE_PATH = "http://innovation.ce.org/Media/";
var VIDEO_PATH = "http://innovation.ce.org/Media/";
var INFO_PATH = "";
var API = "http://innovation.ce.org/API/"

canvas = document.getElementById('slider');
stage = new createjs.Stage(canvas);

screen_width = canvas.width;
screen_height = canvas.height;
createjs.Touch.enable(stage,false,false);
canvas.addEventListener('selectstart', function(e) { e.preventDefault(); return false; }, false);
stage.mouseMoveOutside = true;
createjs.Ticker.addListener(window);
createjs.Ticker.useRAF = true;
createjs.Ticker.setFPS(60);


var leftArrow = new createjs.Shape();
leftArrow.graphics.beginFill(createjs.Graphics.getRGB(175,175,175));
leftArrow.graphics.moveTo(0,0).lineTo(-33,26).lineTo(0,52).closePath();
leftArrow.graphics.endFill();
leftArrow.x = 60;
leftArrow.y = screen_height/2 - 4;
leftArrow.regY =26;

var rightArrow = leftArrow.clone();
rightArrow.scaleX = -1;
rightArrow.x = 1078;

var ua = navigator.userAgent;
if( ua.indexOf("Android") >= 0 )
{
  var androidversion = parseFloat(ua.slice(ua.indexOf("Android")+8)); 
  if (androidversion == 4.1)
  {
      $('#page-content').css({'overflow-x':'visible'});

  }
}

slider = new InnovationSlider(leftArrow,rightArrow);

stage.addChild(slider);
stage.addChild(leftArrow);
stage.addChild(rightArrow);

slider.add();

function tick(){
	stage.update();
}

var elm = document.getElementById("profile"); 

var animation = false,
    animationstring = 'animation',
    keyframeprefix = '',
    domPrefixes = 'Webkit Moz O ms Khtml'.split(' '),
    pfx  = '';
 
if( elm.style.animationName ) { animation = true; }   
 
if( animation === false ) {
  for( var i = 0; i < domPrefixes.length; i++ ) {
    if( elm.style[ domPrefixes[i] + 'AnimationName' ] !== undefined ) {
      pfx = domPrefixes[ i ];
      animationstring = pfx + 'Animation';
      keyframeprefix = '-' + pfx.toLowerCase() + '-';
      animation = true;
      break;
    }
  }
}
