
$("#addStory").hide();
$('.hide_input').hide();
$('.option2').hide();
$('#filter_box').hide();

var pictureSource;   // picture source
var destinationType;
var MOBILE_OS = "none";
var loadedImage = "";

var cam;

var urlParams = {};

$(document).ready(function(){


	document.addEventListener("deviceready",onDeviceReady,false);
	document.addForm.reset();
	clearProfile();
	
	(function () {
		var match,
			pl     = /\+/g,  // Regex for replacing addition symbol with a space
			search = /([^&=]+)=?([^&]*)/g,
			decode = function (s) { return decodeURIComponent(s.replace(pl, " ")); },
			query  = window.location.search.substring(1);

		while (match = search.exec(query))
		   urlParams[decode(match[1])] = decode(match[2]);
	})();
	
	var option = 1;
	
	var lastClick = false;
	
	$('#chooseGraphic').bind('touchstart',function(e){
		e.preventDefault();
		if (option == 1){
			$('.option1').hide();
			$('.option2').show();
			document.getElementById('chooseGraphic').innerHTML = "<u>Or Upload Photo</u>";
			var pic = document.getElementById("sampleImage");
			pic.src = PICTURE_PATH+document.getElementById("Infographic").value+"_320310.png";
			option = 2;
			
			if (MOBILE_OS != "none")
				$('#sampleImage').unbind('touchstart',uploadPhoto);
		}
		else{
			$('.option2').hide();
			$('.option1').show();
			document.getElementById('chooseGraphic').innerHTML = "<u>Or Choose Infographic</u>";
			var files = document.getElementById("File1").files;
			showThumbnail(files);
			option = 1;
			
			if (MOBILE_OS != "none")
				$('#sampleImage').bind('touchstart',uploadPhoto);
		}
	});
	
	$('#filter').bind('touchstart',function(e){
		e.preventDefault();
		window.location.href = "index.html"
		});
	
	
	
	document.getElementById("Infographic").onchange = function(e) { 
	
		var pic = document.getElementById("sampleImage");
		pic.src = PICTURE_PATH+this.value+"_320310.png";
	
	};
	
	document.getElementById("File1").onchange = function(e) { 
	
		var files = this.files;
		showThumbnail(files);
	
	};
	
	function showThumbnail(files){
	  if (MOBILE_OS == "none"){
		  
		  for(var i=0;i<files.length;i++){
			var file = files[i];
			var imageType = /image.*/
			if(!file.type.match(imageType)){
			 specialAlert("Not a valid Image file","Try again");
			  continue;
			}

			var image = document.getElementById("sampleImage");
			image.file = file;

			var reader = new FileReader()
			reader.onload = (function(aImg){
			  return function(e){
				aImg.src = e.target.result;
			  };
			}(image))
			var ret = reader.readAsDataURL(file);
		  }
	  }
	  else{
			var image = document.getElementById("sampleImage");
			if (loadedImage != "")
				image.src = loadedImage;
			else
				image.src = "assets/graphics/smallIcon.png";
	  }
	}
   
   $('form').ajaxForm({
			
			success:function(response) { 
               
			   document.getElementById("submitBut").disabled = false;
			   if (response =="Success"){
				specialAlert ("Your story has been added and is awaiting approval!","Success!");
				$('#addStory').fadeOut(); 
				document.addForm.reset();
				}else{
					specialAlert("Sorry, there was an error in your submission. Make sure all required fields are correct and try again. -" + response,"error");
				}
				
            },
			beforeSerialize: function($form, options){
			
				if(MOBILE_OS !="none" && option == 1){
					mobileSubmit();
					return false;
					
				}
				else{
				if (document.getElementById('Name').value == "")
					specialAlert ("Please enter your name.","Required Field");
				else if(document.getElementById('City').value == ""){
					specialAlert ("Please enter your current city.","Required Field");
				}else if(document.getElementById('Story').value == ""){
					specialAlert ("Please enter some information about your story.","Required Field");
				}else if((document.getElementById('File1').value == "" && option == 1)||(document.getElementById('Infographic').value == "" && option == 2) ){
					specialAlert ("Please upload a photo or choose an infographic.","Required Field");
				}else{
					if (option == 2){
						document.getElementById('File1').setAttribute('type', 'input');
						document.getElementById('File1').setAttribute('type', 'file');
					}
					document.getElementById("submitBut").disabled = true;
					return true;
				}
				return false;
				}
			}
		});
		
	$('#close_button').bind('touchstart',function(e){
		e.preventDefault();
		
		if (!animation)
			$('#profile').animate({left:'-100%'},{duration:1000,complete:doneSliding});
		else{
			setTimeout(doneSliding,1000);
			$("#profile").removeClass("profile_in");
		}
		
		function doneSliding()
		{
			//document.getElementById("prof_vid").pause();
			clearProfile();
		
		}
	});
	
	$('#close_story').bind('touchstart',function(e){
		e.preventDefault();
		$('#addStory').fadeOut();
	});
	
	$('#story').bind('touchstart', function(e){
		e.preventDefault();
		$('#addStory').fadeIn();
	});
});


function onDeviceReady(){
	
	if (navigator.network.connection.type == Connection.NONE){
		specialAlert('You must have an internet connection to run "Innovation"',"No Connection");
		document.getElementsByTagName('body')[0].innerHTML = "<img src='assets/graphics/footer_logo.png' style='width:90%; display:block; padding-top:20%; margin:auto;'/>";
		navigator.device.exitApp();
		
		
	}
	MOBILE_OS = device.platform;
	navigator.splashscreen.hide();
	adjustForMobile();
	document.addEventListener("offline", goesOffline, false);
	document.addEventListener("pause", appPaused, false);
	
	
	cam = new CameraAccess();
}

function appPaused(){
	profVid = document.getElementById('prof_vid');
	if (profVid)
		profVid.pause();
}

function goesOffline(){
	specialAlert ("You must be online to access I Am Innovation!","Connection Error");
	document.getElementsByTagName('body')[0].innerHTML = "<img src='assets/graphics/footer_logo.png' style='width:90%; display:block; padding-top:20%; margin:auto;'/>";

	navigator.device.exitApp();
	
}

function CameraAccess(){
	
	this.useExistingPhoto = function(e) {
	  capture(Camera.PictureSourceType.SAVEDPHOTOALBUM);
	};

	// take a new photo:
	this.takePhoto = function(e) {
	  capture(Camera.PictureSourceType.CAMERA);
	};

	// capture either new or existing photo:
	capture = function(sourceType) {
		navigator.camera.getPicture(onCaptureSuccess, onCaptureFail, {
			quality:50,
			destinationType: Camera.DestinationType.FILE_URI,
			sourceType: sourceType,
			correctOrientation: true
		  });
	};

	// if photo is captured successfully, then upload to server:
	function onCaptureSuccess(imageURI) {
		loadedImage = imageURI;
		var image = document.getElementById("sampleImage");	
		image.src = loadedImage;
	};

	// there was an error capturing the photo:
	function onCaptureFail(message) {
	  specialAlert("Couldn't upload image","Upload error");
	};
}

function mobileSubmit(){
	

	if (document.getElementById('Name').value == "")
		specialAlert ("Please enter your name.","Required Field");
	else if(document.getElementById('City').value == ""){
		specialAlert ("Please enter your current city.","Required Field");
	}else if(document.getElementById('Story').value == ""){
		specialAlert ("Please enter some information about your story.","Required Field");
	}else if(loadedImage ==""){
		specialAlert ("Please upload a photo or choose an infographic.","Required Field");
	}else{

		  var options = new FileUploadOptions();
		  options.fileKey = "File1";
		 
		  options.fileName = loadedImage.substr(loadedImage.lastIndexOf('/') + 1);
		  
		  var params = {
			TaglineID: document.getElementById('TaglineID').value,
			Name: document.getElementById('Name').value,
			HomeCountry: document.getElementById('HomeCountry').value,
			College: document.getElementById('College').value,
			Degree: document.getElementById('Degree').value,
			City: document.getElementById('City').value,
			State: document.getElementById('State').value,
			Zip: document.getElementById('Zip').value,
			CEmail: document.getElementById('CEmail').value,
			Story: document.getElementById('Story').value,
			Infographic: document.getElementById('Infographic').value,
			Video: document.getElementById('Video').value,
			StoryID: document.getElementById('StoryID').value,
			CreatedBy: document.getElementById('CreatedBy').value
		  };
		  options.params = params;
		  var ft = new FileTransfer();
		  document.getElementById("submitBut").disabled = true;
		 ft.upload(loadedImage, encodeURI(API+'addStory.aspx'), success, fail, options);
	
	}
	
	function success(response) {
		document.getElementById("submitBut").disabled = false;
		if (response.response == "Success"){
			specialAlert ("Your story has been added and is awaiting approval!","Success!");
			$('#addStory').fadeOut();
			document.getElementById("submitBut").disabled = false;
			document.addForm.reset();
		}
		else{
			specialAlert("Sorry, there was an error in the submission. Make sure all required fields are correct and try again. -" + response.response,"Error");
			}
	  };
	  
	  // callback if the photo fails to upload successfully.
	  
	  function fail(error) {
		document.getElementById("submitBut").disabled = false;
		specialAlert("An error has occurred: Code = " + error.code,"Error");
	  };
	  
	 
}


function adjustForMobile(){

	var ops = document.getElementsByClassName('option1');
	ops[0].innerHTML = "*Tap to upload a Photo of You";
	document.getElementById('File1').className = "noOption";
	$('#File1').hide();
	
	$('#sampleImage').bind('touchstart',uploadPhoto);
	
	
}

function uploadPhoto(e){

		e.preventDefault();
		 navigator.notification.confirm(
        'How would you like to choose your picture?',  // message
        uploadSelection,              // callback to invoke with index of button pressed
        'Add a Photo',            // title
        'Use the Camera, Upload a Photo'          // buttonLabels
    );
	
	function uploadSelection(choice){
		if (choice == 1)
			cam.takePhoto();
		if (choice == 2)
			cam.useExistingPhoto();
	}

	
}

function specialAlert(message,title){
	if (MOBILE_OS == "none")
		alert(message);
	else{
		navigator.notification.alert(message,function(){},title);
	}
}

function populateAddStory(lines){
	var insert = "";
	for (var i in lines){
	
			var opt = "<option value='"+(parseInt(i)+1)+"'>"+lines[i]+"</option>";
			insert += opt;
	}
	document.getElementById("TaglineID").innerHTML = insert;
	
	$.getJSON(API+"Countries", function(json) {
	   
	   var cInsert = "";
	   for (var i = 0; i < json.length;i++){
			var opt = "<option value='"+json[i]+"'>"+json[i]+"</option>";
			cInsert += opt;
	   }
	   
	   document.getElementById("HomeCountry").innerHTML = cInsert;
	   
	 });
	 
	 $.getJSON(API+"States", function(json) {
	   
	   var sInsert = "";
	   for (var i = 0; i < json.length;i++){
			var opt = "<option value='"+json[i]+"'>"+json[i]+"</option>";
			sInsert += opt;
	   }
	   
	   document.getElementById("State").innerHTML = sInsert;
	   
	 });
	 
	 $.getJSON(API+"Filters", function(json) {
	   
	   var fInsert = "<p>Show All</p>";
	   for (var i = 0; i < json.length;i++){
			var opt = "<p>"+json[i].Name+"</p>";
			fInsert += opt;
	   }
	   
	   document.getElementById("filter_box").innerHTML = fInsert;
	   
	   var filts = document.getElementById("filter_box").getElementsByTagName("p");
	   
	   for (var i = 0; i < filts.length;i++){
			filts[i].value = i;
			$(filts[i]).bind('touchstart',function(e){
				e.preventDefault();
				boxOut(e);
			});
	   }
	   
	 });
	 
	 $.getJSON(API+"InfoGraphics", function(json) {
	   
	   var iInsert = "";
	   for (var i = 0; i < json.length;i++){
			var opt;
			if (i == 0)
				opt = "<option value='"+json[i].FileName+"' selected>"+json[i].Description+"</option>";
			else
				opt = "<option value='"+json[i].FileName+"'>"+json[i].Description+"</option>";
			iInsert += opt;
	   }
	   
	   document.getElementById("Infographic").innerHTML = iInsert;
	   
	 });
}

function Innovator(info,taglines){

	this.name;
	this.picture;
	this.video;
	this.about;
	this.college;
	this.degree;
	this.city;
	this.state;
	this.country;
	this.id;
	this.tagline;
	this.blurb;
	this.priority;
	this.ext;
	this.used = false;
	
	var self = this;
	
	if (info){
		this.name = info.Name;
		this.picture = info.Photo;
		this.video = info.Video;
		this.tagline = taglines[info.TaglineID-1];
		this.college = info.College;
		this.degree = info.Degree;
		this.country = info.HomeCountry;
		this.city = info.City;
		this.state = info.State;
		this.ext = info.PhotoExtension;
		this.id = info.StoryID;
		this.about = "";
		if (info.City){
			this.about += info.City; 
			if (info.State)
				this.about += ", "
			else
				this.about +="<br>"
		}
		if (info.State)
			this.about += info.State +"<br>";
		if (info.College)
			this.about += "School: "+ info.College +"<br>";
		if (info.Degree)
			this.about += "Degree: "+ info.Degree +"<br>";
		if (info.HomeCountry && info.HomeCountry !="USA")
			this.about += "Home Country: "+ info.HomeCountry;
			
		this.blurb = info.Story;
		this.priority = info.StoryLevel;		
	}
	
	

}


var hasVideo = false;

function clearProfile(){
	var pers = document.getElementById("person");
	pers.getElementsByTagName("p").innerHTML = "";
	document.getElementById("wrapVid").innerHTML = "<img class='pers_central' id='photo'></img>";
	$('#photo').hide();
	//$('#wrapVid').hide();
	$('#photo').unbind('touchstart');
	
	var blurb = document.getElementById("blurb");
	var ps = blurb.getElementsByTagName("p");
	
	for (var i = 0; i < ps.length-2; i++)
		ps[i].innerHTML = "";
}

function populateProfile(innov){

	var pers = document.getElementById("person");
	var profPic = document.getElementById("photo");
	var profVid;
	
	addIndShare(innov);
	
	profPic.onload = function(){
		
		$('#photo').show();
		
		setTimeout(function(){
			if (!animation)
				$('#profile').animate({left:'6.508355321020229%'},1000);
			else
				$("#profile").addClass("profile_in");
		},200);
	}
	
	$('#photo').hide();
	
	profPic.src = "";

	profPic.src = PICTURE_PATH+ innov.picture+"_475450.png";


	if (innov.video){
		$('#photo').bind('touchstart',function(e){
			e.preventDefault();
			$('#photo').hide();
			document.getElementById("wrapVid").innerHTML = "<img class='pers_central' id='photo'></img><video width='100%' class='pers_central' id='prof_vid'></video>"+
				"<div style='background: #f0f0f0;border:0px;' class='pers_central'><img width='15%' src='assets/graphics/button_pause.png' style='float:left;' id='play_but'/>"+
				"<img width='15%' src='assets/graphics/button_fullscreen.png' style='float:right;' id='fullscreen'/>"+"<div style='clear: both' width='100%'></div></div>" ;
			
			profVid = document.getElementById('prof_vid');
			$("#prof_vid").bind('play',function(){
				document.getElementById('play_but').src = "assets/graphics/button_pause.png";
				$('#play_but').unbind('touchstart',playIt);
				$('#play_but').bind('touchstart',pauseIt);
			});
			
			$("#prof_vid").bind('pause',function(){
				document.getElementById('play_but').src = "assets/graphics/button_play.png";
				$('#play_but').unbind('touchstart',pauseIt);
				$('#play_but').bind('touchstart',playIt);
			})
			
			$('#play_but').bind('touchstart',pauseIt);

			$('#fullscreen').bind('touchstart',function(e){
				e.preventDefault();
				if (profVid.requestFullScreen) {
				  profVid.requestFullScreen();
				} else if (profVid.mozRequestFullScreen) {
				  profVid.mozRequestFullScreen();
				} else if (profVid.webkitRequestFullScreen) {
				  profVid.webkitRequestFullScreen();
				} else if(profVid.webkitEnterFullScreen){
					profVid.webkitEnterFullScreen();
				}
			});
			
			function playIt(e){
				e.preventDefault();
				profVid.play();
				this.src = "assets/graphics/button_pause.png";
				$('#play_but').unbind('touchstart',playIt);
				$('#play_but').bind('touchstart',pauseIt);
			}
			
			function pauseIt(e){
				e.preventDefault();
				profVid.pause();
				this.src = "assets/graphics/button_play.png";
				$('#play_but').unbind('touchstart',pauseIt);
				$('#play_but').bind('touchstart',playIt);
			}
			
			setVideoProperties(profVid);
		
			var vidSpecs = "<source src='"+VIDEO_PATH+innov.video+".mp4'>";
			
			profVid.innerHTML = vidSpecs;
			
			//profVid.load();
			profVid.play();
		});
		
	}
	persP = pers.getElementsByTagName("p");
	persP[0].innerHTML = innov.name;
	persP[1].innerHTML = innov.about;
	
	var blurb = document.getElementById("blurb");
	var blurbP = blurb.getElementsByTagName("p");
	blurbP[0].innerHTML = "I am "+innov.name+ ".<br>I am innovation.";
	blurbP[1].innerHTML = innov.tagline;
	
	blurb.getElementsByTagName("div")[0].innerHTML = innov.blurb;
}

function setVideoProperties(vid){
	vid.autoplay = true;
	vid.onload = function(){}
	vid.onended = function(){
		//$('#photo').show();
		this.load();
	}
}

function shuffle ( myArray ) {
  var i = myArray.length;
  if ( i == 0 ) return false;
  while ( --i ) {
     var j = Math.floor( Math.random() * ( i + 1 ) );
     var tempi = myArray[i];
     var tempj = myArray[j];
     myArray[i] = tempj;
     myArray[j] = tempi;
   }
}

function addIndShare(innov){
	
	
	var twit = "http://twitter.com/intent/tweet?source=sharethiscom&text="+encodeURIComponent(innov.name+": ")+"I%20Am%20Innovation%20%23iaminnovation&url=http%3A%2F%2Finnovation.ce.org%3Fprof%3D"+innov.id;
	var face = "http://www.facebook.com/sharer.php?u=http%3A%2F%2Finnovation.ce.org%3Fprof%3D"+innov.id+"&t="+encodeURIComponent(innov.name+": ")+"I%20am%20Innovation";
	var goog = "https://plus.google.com/share?url=http%3A%2F%2Finnovation.ce.org%3Fprof%3D"+innov.id;
	var link = "http://www.linkedin.com/shareArticle?mini=true&url=http%3A%2F%2Finnovation.ce.org%3Fprof%3D"+innov.id+"&title="+encodeURIComponent(innov.name+": ")+"I%20Am%20Innovation&source=http%3A%2F%2Finnovation.ce.org";
	
	var i_sh = document.getElementById('ind_share');
	
	i_sh.innerHTML = '';
	
	i_sh.innerHTML = "<img id='i_twitter' class='shareButton' src='http://innovation.ce.org/assets/graphics/twitter.png'/>"+
		"<img id='i_facebook' class='shareButton' src='http://innovation.ce.org/assets/graphics/facebook.png'/>"+
		"<img id='i_googleplus' class='shareButton' src='http://innovation.ce.org/assets/graphics/googleplus.png'/>"+
		"<img id='i_linkedin' class='shareButton' src='http://innovation.ce.org/assets/graphics/linkedin.png'/>";
	
	$('#i_twitter').unbind('touchstart');	
	$('#i_twitter').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(twit);
	});
	
	$('#i_facebook').unbind('touchstart');
	$('#i_facebook').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(face);
	});
	
	$('#i_googleplus').unbind('touchstart');
	$('#i_googleplus').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(goog);
	});
	
	$('#i_linkedin').unbind('touchstart');
	$('#i_linkedin').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(link);
	});
	
	$('.shareButton').css('margin-left','20px');
}

$(document).ready(function(){
	
	setShares();
	$(window).resize(function() {
        setShares();
    });
	
	$('#disclaimer').attr('onClick',"window.plugins.childBrowser.showWebPage('http://innovation.ce.org/legal');");
	

});

function setShares(){
	var sh = document.getElementById('share');
	var twit = "http://twitter.com/intent/tweet?source=sharethiscom&text=I%20Am%20Innovation%20%23iaminnovation&url=http%3A%2F%2Finnovation.ce.org"
	var face = "http://www.facebook.com/sharer.php?u=http%3A%2F%2Finnovation.ce.org&t=I%20am%20Innovation";
	var goog = "https://plus.google.com/share?url=http%3A%2F%2Finnovation.ce.org"
	var link = "http://www.linkedin.com/shareArticle?mini=true&url=http%3A%2F%2Finnovation.ce.org&title=I%20Am%20Innovation&source=http%3A%2F%2Finnovation.ce.org"
	sh.innerHTML = '';
	
	sh.innerHTML = "<img id='twitter' class='shareButton' src='http://innovation.ce.org/assets/graphics/twitter.png'/>"+
		"<img id='facebook' class='shareButton' src='http://innovation.ce.org/assets/graphics/facebook.png'/>"+
		"<img id='googleplus' class='shareButton' src='http://innovation.ce.org/assets/graphics/googleplus.png'/>"+
		"<img id='linkedin' class='shareButton' src='http://innovation.ce.org/assets/graphics/linkedin.png'/>";
	
	

	$('#twitter').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(twit);
	});
	
	$('#facebook').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(face);
	});
	
	$('#googleplus').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(goog);
	});
	
	$('#linkedin').bind('touchstart',function(e){
		e.preventDefault();
		window.plugins.childBrowser.showWebPage(link);
	});
	
	
		
	$('.shareButton').css('margin-left','20px');
}


