function adjustStyle(width,height) {
    width = parseInt(width);
	height = parseInt(height);
	
   if (width < 769) {
		$('#share').insertAfter('#story');
		$('#options').insertAfter('#mapView');
		if (width < height*1.6){
			$("#size-stylesheet").attr("href", "css/small.css");
		}
		else{
			$('#options').insertAfter('#headline');
			$('#share').insertAfter('#logo');
			$("#size-stylesheet").attr("href", "css/small-landscape.css");
		}
    } else if ((width >= 769) && (width < 900)) {
		$('#share').insertAfter('#logo');
		$('#options').insertAfter('#headline');
        if (height > width*1.4){
			$('#options').insertAfter('#mapView');
			$("#size-stylesheet").attr("href", "css/small.css");
		}
		else{
			$("#size-stylesheet").attr("href", "css/medium.css");
		}
    } else {
		$('#share').insertAfter('#logo');
		$('#options').insertAfter('#headline');
		if (width < height*1.6){
			$("#size-stylesheet").attr("href", "css/large.css"); 
	   }
	   else{
			$("#size-stylesheet").attr("href", "css/large-landscape.css");
	   }
    }
	
	$('#mapView').height($('#mapView').width()/1.833870967741935);
	setTimeout(function(){$('#mapView').height($('#mapView').width()/1.833870967741935);},2000);

}


$(function() {
	setTimeout(function(){
		adjustStyle($(this).width(),$(this).height());
	},100);
    $(window).resize(function() {
        adjustStyle($(this).width(),$(this).height());
    });
});